﻿

namespace PDF_TO_PDF_OCR
{
  using System;
  using System.Diagnostics;
  using System.IO;
  using System.Linq;
  using System.Windows.Forms;
  using GdPicture14;

  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }
    
    private bool _cancellationPending;

    private void Form1_Load(object sender, System.EventArgs e)
    {
      LicenseManager oLicenseManager = new LicenseManager(); //Go to http://www.gdpicture.com/download-gdpicture/ to get a 1 month trial key unlocking all features of the toolkit.
      oLicenseManager.RegisterKEY("XXX"); //Please, replace XXX by a valid demo or commercial license key.
    }

    private void btStartOCR_Click(object sender, System.EventArgs e)
    {
      RunOcr();
    }

    private void RunOcr()
    {
      var files = Directory.GetFiles(txtInputFile.Text);
      foreach (var file in files)
      {
        using (var pdf = new GdPicturePDF())
        {
          pdf.LoadFromFile(file);
          if (pdf.OcrPages("*", 0, "eng", txtDictsPath.Text, string.Empty, 300, OCRMode.FavorAccuracy, 30000, true) != GdPictureStatus.OK)
          {
            throw new Exception("Ocr failed");
          }

          pdf.ClearCachedResources();
          pdf.CloseDocument();
          GdPictureDocumentUtilities.ForceGarbageCollection();
        }
      }
    }

    private void btBrowsInput_Click(object sender, System.EventArgs e)
    {
      using (var openFileDialog1 = new FolderBrowserDialog())
      {
        openFileDialog1.SelectedPath = txtInputFile.Text;
        if (openFileDialog1.ShowDialog() == DialogResult.OK)
        {
          txtInputFile.Text = openFileDialog1.SelectedPath;
        }
      }
    }

    private void btBrowsOCRDict_Click(object sender, System.EventArgs e)
    {
      using (FolderBrowserDialog folderBrowserDialog1 = new FolderBrowserDialog())
      {
        folderBrowserDialog1.SelectedPath = txtDictsPath.Text;
        if (folderBrowserDialog1.ShowDialog() == DialogResult.OK)
        {
          txtDictsPath.Text = folderBrowserDialog1.SelectedPath;
        }
      }
    }
  }
}